#pragma warning(disable:4786)
#include <stdio.h>
#include "OsiClpSolverInterface.hpp"
#include "OsiGlpkSolverInterface.hpp"
#include "cplex_register.h"
#include "OsiCpxSolverInterface.hpp"

#include "test1.h"
#include "test2.h"
#include "test3.h"
#include "test4.h"
#include "test5.h"
#include "test6.h"
#include "test7.h"

#include <vector>

typedef bool (*TestFunction)(OsiSolverInterface*, const char*);

int main()
{
	OsiSolverInterface *s = NULL;
	int i;

	bool ret = true;

	std::vector<TestFunction> test_functions;	
	test_functions.push_back(&test1_solve);
	test_functions.push_back(&test2_solve);
	test_functions.push_back(&test3_solve);
	test_functions.push_back(&test4_solve);
	test_functions.push_back(&test5_solve);
	test_functions.push_back(&test6_solve);
	test_functions.push_back(&test7_solve);

	for (i = 0; i < test_functions.size(); ++i) {
		s = new OsiClpSolverInterface();
		bool test = test_functions[i](s, "clp");
		ret = ret && test;
		delete s;
	}

	for (i = 0; i < test_functions.size(); ++i) {
		s = new OsiGlpkSolverInterface();
		bool test = test_functions[i](s, "glpk");
		ret = ret && test;
		delete s;
	}

	registerCplex();
	for (i = 0; i < test_functions.size(); ++i) {
		s = new OsiCpxSolverInterface();
		bool test = test_functions[i](s, "cpx");
		ret = ret && test;
		delete s;
	}

	return ret;
}
